<!DOCTYPE html>
<html>

<head>
    <title>Lucky Dice Casino Task 44.40 To Task 44.50</title>
    <meta charset='utf-8'>
    <meta name='viewport' content='width=device-width, initial-scale=1'>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- class CSS để dùng trong bài -->
    <style>
        .picture-cover { 
            background-image: url("LuckyDiceImages/cover.jpg");
            min-height: 100px;
            margin: 5px;
        }
    </style>
</head>

<body>
    <div class="container-fluid  picture-cover">
        
    </div>
    <div class="container ">
        <div class="row ">
            <div class="col-5 bg-white  ">
                <div class="row  form-group">
                    <div class="col-12"> <!-- Tại dòng 2.1.1.1 thêm một div column rộng 12 đơn vị -->
                        <h4>Nhập thông tin của bạn</h4>
                    </div>
                </div>
                <div class="row   form-group"> <!-- tại mỗi dòng 2.1.1.2 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  "> <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Username</label>
                    </div>
                    <div class="col-8  "> <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-user-name" class="form-control" type="text">
                    </div>
                </div>
                <div class="row   form-group"> <!-- tại mỗi dòng 2.1.1.3 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  ">  <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Firstname</label>
                    </div>
                    <div class="col-8  ">  <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-first-name" class="form-control" type="text">
                    </div>
                </div>
                <div class="row   form-group"><!-- tại mỗi dòng 2.1.1.4 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  ">  <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Lastname</label>
                    </div>
                    <div class="col-8  "> <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-last-name" class="form-control" type="text">
                    </div>
                </div>
            </div>
            <div class="col-4  text-center"> <!-- Tại cột 2.1.2 tạo 3 div class row, cột 2.1.2 có thuộc tính căn giữa -->
               <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <input id="btn-dice" class="btn btn-success button-width w-75" value="Ném" type="button">
                    </div>
               </div>
               <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị-->
                        <img id="img-dice" class="img-thumbnail" src="LuckyDiceImages/dice.png">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <p id="p-notification-dice">Chúc mừng</p>
                    </div>
                </div>
            </div>
            <div class="col-3  text-center"> <!-- Tại cột 2.1.3 tạo 2 div class row, cột 2.1.3 có thuộc tính căn giữa -->
                <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <p>Voucher</p>
                        <p id="p-voucher-id">No ID</p>
                        <p id="p-voucher-percent">0%</p>
                    </div>
               </div>
               <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị-->
                        <img id="img-present" class="img-thumbnail" src="LuckyDiceImages/motobike.jpg">
                    </div>
                </div>
            </div>
        </div>
        <div class="row  text-center form-group"> <!-- Tại row 2.2 thêm một div column rộng 12 đơn vị  -->
            <div class="col-12">
                <button id="btn-dice-history" class="btn btn-info button-width w-25">Dice History</button>
                <button id="btn-voucher-history" class="btn btn-success button-width w-25">Voucher History</button>
                <button id="btn-present-history" class="btn btn-success button-width w-25">Present History</button>
            </div>
        </div>
        <div class="row "> <!-- Tại row 2.3 thêm một div column rộng 12 đơn vị  -->
            <div class="col-12">
                <table id="history-placeholder-table" class="table table-striped table-hover ">
                    <tr>
                        <th>Lượt</th>
                        <th>Dice</th>
                    </tr>
                    <tr>
                        <td>1</td>
                        <td>2</td>
                    </tr>
                    <tr>
                        <td>2</td>
                        <td>6</td>
                    </tr>
                    <tr>
                        <td>3</td>
                        <td>4</td>
                    </tr>
                    <tr>
                        <td>4</td>
                        <td>5</td>
                    </tr>
                    <tr>
                        <td>5</td>
                        <td>4</td>
                    </tr>
                </table>
            </div>
        </div>
    </div>
</body>
<script>
    "use strict";

    // Vùng 1: Khai báo biến toàn cục


    // Vùng 2: Vùng gán
    $('#btn-dice').on('click', onBtnDiceClick);

    // Vùng 3: Vùng khai báo hàm xử lý sự kiện
    // Hàm xử lý khi ấn nút Ném
    function onBtnDiceClick() {
        "use strict";
        // Bước 0: Tạo đối tượng để lưu dữ liệu
        var vUserObj = {
            username: "",
            firstname: "",
            lastname: ""
        };

        // Bước 1: Thu thập dữ liệu từ input
        getDataUserFromInput(vUserObj);
        //console.log(vUserObj);

        // Bước 2: Validate data user thu thập đc ở bước 1
        var vCheckUser = validateUser(vUserObj);
        //console.log(vCheckUser);
        if (vCheckUser == true) {
            // Bước 3: Call api post new dice
            callApiPostNewDice(vUserObj);
        }
    }

    // Vùng 4: Vùng khai báo hàm dùng chung
    // Hàm thu thập dữ liệu user từ input
    function getDataUserFromInput(paramUserObj) {
        "use strict";
        paramUserObj.username = $.trim($('#inp-user-name').val());
        paramUserObj.firstname = $.trim($('#inp-first-name').val());
        paramUserObj.lastname = $.trim($('#inp-last-name').val());
    }

    // Hàm validate data user thu thập từ bước 1
    function validateUser(paramUserObj) {
        "use strict";
        if (paramUserObj.username == "") {
            alert('Chưa nhập Username!');
            return false;
        }
        if (paramUserObj.firstname == "") {
            alert('Chưa nhập Firstname!');
            return false;
        }
        if (paramUserObj.lastname == "") {
            alert('Chưa nhập Lastname!');
            return false;
        }
        return true;
    }

    // Hàm call api post new dice
    function callApiPostNewDice(paramUserObj) {
        "use strict";
        var vJsonUser = JSON.stringify(paramUserObj);
        //console.log(vJsonUser);
        $.ajax({
            url: "http://42.115.221.44:8080/devcamp-lucky-dice//dice",
            type: 'POST',
            dataType: 'json',
            data: vJsonUser,
            contentType: "application/json;charset=UTF-8",
            success: function(res) {
                //console.log(res);
                callBackNewDiceProcess(res);
            },
            error: function(error) {
                console.log(error.responseText);
            }
        });
    }

    // Hàm call back gọi API thành công
    function callBackNewDiceProcess(paramResult) {
        "use strict";
        console.log(JSON.stringify(paramResult));
        switch(paramResult.dice) {
            case 1:
                $('#img-dice').removeAttr('src')
                            .attr('src', 'LuckyDiceImages/1.png');
                $('#p-notification-dice').html("Chúc bạn may mắn lần sau!");
                break;
            case 2:
                $('#img-dice').removeAttr('src')
                            .attr('src', 'LuckyDiceImages/2.png');
                $('#p-notification-dice').html("Chúc bạn may mắn lần sau!");
                break;
            case 3:
                $('#img-dice').removeAttr('src')
                            .attr('src', 'LuckyDiceImages/3.png');
                $('#p-notification-dice').html("Chúc bạn may mắn lần sau!");
                break;
            case 4:
                $('#img-dice').removeAttr('src')
                            .attr('src', 'LuckyDiceImages/4.png');
                $('#p-notification-dice').html("Chơi thêm ván nữa nhé!");
                break;
            case 5:
                $('#img-dice').removeAttr('src')
                            .attr('src', 'LuckyDiceImages/5.png');
                $('#p-notification-dice').html("Chơi thêm ván nữa nhé!");
                break;
            default:
                $('#img-dice').removeAttr('src')
                            .attr('src', 'LuckyDiceImages/6.png');
                $('#p-notification-dice').html("Chơi thêm ván nữa nhé!");
        }
        if (paramResult.voucher != null) {
            $('#p-voucher-id').html("VoucherID: " + paramResult.voucher.id);
            $('#p-voucher-percent').html("Discount: " + paramResult.voucher.phanTramGiamGia + "%");
        }
        else {
            $('#p-voucher-id').html("Không có voucher!");
            $('#p-voucher-percent').html("Giảm giá 0%!");
        }
        switch(paramResult.prize) {
            case "Áo":
                $('#img-present').removeAttr('src')
                            .attr('src', 'LuckyDiceImages/t-shirt.jpg');
                break;
            case "Mũ":
                $('#img-present').removeAttr('src')
                            .attr('src', 'LuckyDiceImages/hat.jpg');
                break;
            case "Ô tô":
                $('#img-present').removeAttr('src')
                            .attr('src', 'LuckyDiceImages/car.jpg');
                break;
            case "Xe máy":
                $('#img-present').removeAttr('src')
                            .attr('src', 'LuckyDiceImages/xe-may.jpg');
                break;
            default:
                $('#img-present').removeAttr('src')
                            .attr('src', 'LuckyDiceImages/no-present.jpg');
        }
    }

</script>

</html>